﻿<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:msa="http://www.publictalksoftware.co.uk/msa">

	<xsl:param name="selectedDate" select="''"/>
	<xsl:param name="selectedName" select="''"/>
	
	<xsl:param name="index1" select="'Sound 1'"/>
	<xsl:param name="index2" select="'Sound 2'"/>
	<xsl:param name="index3" select="'Sound 3'"/>
	<xsl:param name="index4" select="'Sound 4'"/>
	<xsl:param name="index5" select="'Platform'"/>
	<xsl:param name="index6" select="'Platform Microphone'"/>
	<xsl:param name="index7" select="'Microphone 1'"/>
	<xsl:param name="index8" select="'Microphone 2'"/>
	<xsl:param name="index9" select="'Microphone 3'"/>
	<xsl:param name="index10" select="'Microphone 4'"/>
	<xsl:param name="index11" select="'Microphone 5'"/>
	<xsl:param name="index12" select="'Microphone 6'"/>
	<xsl:param name="index13" select="'Attendant 1'"/>
	<xsl:param name="index14" select="'Attendant 2'"/>
	<xsl:param name="index15" select="'Attendant 3'"/>
	<xsl:param name="index16" select="'Attendant 4'"/>
	<xsl:param name="index17" select="'Cleaning 1'"/>
	<xsl:param name="index18" select="'Cleaning 2'"/>
	
	<xsl:param name="indexCustomFixed0" select="'CBS Conductor'"/>
	<xsl:param name="indexCustomFixed1" select="'CBS Reader'"/>
	<xsl:param name="indexCustomFixed2" select="'Midweek Chairman'"/>
	<xsl:param name="indexCustomFixed3" select="'Midweek Prayer'"/>
	<xsl:param name="indexCustomFixed4" select="'Host'"/>
	<xsl:param name="indexCustomFixed5" select="'Co-host'"/>
	<xsl:param name="indexCustomFixed6" select="'Zoom Attendant'"/>

	<xsl:output method="html" encoding="UTF-8" indent="yes"/>

	<!-- Template to match the root and start the transformation -->
	<xsl:template match="/">
		<html>
			<head>
				<title>Filtered Duty Assignment History</title>
				<link rel="stylesheet" type="text/css" href="Custom--S-140--DutyHistory.css"/>
			</head>
			<body>
				<h2>
					Filtered Duty Assignment History for <xsl:value-of select="$selectedName"/>
				</h2>
				<h4>
					<xsl:text>Since: </xsl:text>
					<xsl:value-of select="substring($selectedDate, 7, 2)"/>
					<!-- DD -->
					<xsl:text>/</xsl:text>
					<xsl:value-of select="substring($selectedDate, 5, 2)"/>
					<!-- MM -->
					<xsl:text>/</xsl:text>
					<xsl:value-of select="substring($selectedDate, 1, 4)"/>
					<!-- YYYY -->
				</h4>
				<table class="history-table">
					<tr>
						<th><xsl:text>Date</xsl:text></th>
						<th><xsl:text>Mode</xsl:text></th>
						<th><xsl:text>Duty</xsl:text></th>
						<th><xsl:text>Name</xsl:text></th>
					</tr>
					<xsl:apply-templates select="//msa:DutyAssignmentEntry/msa:Assignment[text() = $selectedName and translate(../@Date, '-', '') &gt; translate($selectedDate, '-', '')]"/>
				</table>
			</body>
		</html>
	</xsl:template>

	<!-- Template to display each filtered duty assignment -->
	<xsl:template match="msa:Assignment">
		<tr>
			<td>
				<xsl:variable name="date" select="../@Date"/>
				<xsl:value-of select="substring($date, 9, 2)"/>
				<!-- DD -->
				<xsl:text>/</xsl:text>
				<xsl:value-of select="substring($date, 6, 2)"/>
				<!-- MM -->
				<xsl:text>/</xsl:text>
				<xsl:value-of select="substring($date, 1, 4)"/>
				<!-- YYYY -->
			</td>
			<td>
				<xsl:value-of select="../@Mode"/>
			</td>
			<td>
				<xsl:choose>
					<xsl:when test="@IndexType='Fixed'">
						<xsl:choose>
							<xsl:when test="@Index='1'"><xsl:value-of select="$index1"/></xsl:when>
							<xsl:when test="@Index='2'"><xsl:value-of select="$index2"/></xsl:when>
							<xsl:when test="@Index='3'"><xsl:value-of select="$index3"/></xsl:when>
							<xsl:when test="@Index='4'"><xsl:value-of select="$index4"/></xsl:when>
							<xsl:when test="@Index='5'"><xsl:value-of select="$index5"/></xsl:when>
							<xsl:when test="@Index='6'"><xsl:value-of select="$index6"/></xsl:when>
							<xsl:when test="@Index='7'"><xsl:value-of select="$index7"/></xsl:when>
							<xsl:when test="@Index='8'"><xsl:value-of select="$index8"/></xsl:when>
							<xsl:when test="@Index='9'"><xsl:value-of select="$index9"/></xsl:when>
							<xsl:when test="@Index='10'"><xsl:value-of select="$index10"/></xsl:when>
							<xsl:when test="@Index='11'"><xsl:value-of select="$index11"/></xsl:when>
							<xsl:when test="@Index='12'"><xsl:value-of select="$index12"/></xsl:when>
							<xsl:when test="@Index='13'"><xsl:value-of select="$index13"/></xsl:when>
							<xsl:when test="@Index='14'"><xsl:value-of select="$index14"/></xsl:when>
							<xsl:when test="@Index='15'"><xsl:value-of select="$index15"/></xsl:when>
							<xsl:when test="@Index='16'"><xsl:value-of select="$index16"/></xsl:when>
							<xsl:when test="@Index='17'"><xsl:value-of select="$index17"/></xsl:when>
							<xsl:when test="@Index='18'"><xsl:value-of select="$index18"/></xsl:when>
						</xsl:choose>
					</xsl:when>
					<xsl:when test="@IndexType='CustomFixed'">
						<xsl:choose>
							<xsl:when test="@Index='0'"><xsl:value-of select="$indexCustomFixed0"/></xsl:when>
							<xsl:when test="@Index='1'"><xsl:value-of select="$indexCustomFixed1"/></xsl:when>
							<xsl:when test="@Index='2'"><xsl:value-of select="$indexCustomFixed2"/></xsl:when>
							<xsl:when test="@Index='3'"><xsl:value-of select="$indexCustomFixed3"/></xsl:when>
							<xsl:when test="@Index='4'"><xsl:value-of select="$indexCustomFixed4"/></xsl:when>
							<xsl:when test="@Index='5'"><xsl:value-of select="$indexCustomFixed5"/></xsl:when>
							<xsl:when test="@Index='6'"><xsl:value-of select="$indexCustomFixed6"/></xsl:when>
						</xsl:choose>
					</xsl:when>
				</xsl:choose>
			</td>
			<td>
				<xsl:value-of select="."/>
			</td>
		</tr>
	</xsl:template>

</xsl:stylesheet>
